# std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r > Class Template Reference
[Random Number Generators]

List of all members.

## Detailed Description

### template<typename _RealType, int __w, int __s, int __r>
class std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >

Definition at line 843 of file random.

## Public Types

- typedef _RealType result_type

## Public Member Functions

- result_type max () const
- result_type min () const
- result_type operator() ()
- template<class _Gen> void seed (_Gen &__g)
- void seed (unsigned long __value=19780503)
- template<class _Gen> subtract_with_carry_01 (_Gen &__g)
- subtract_with_carry_01 (unsigned long __value)
- subtract_with_carry_01 ()

## Static Public Attributes

- static const int long_lag
- static const int short_lag
- static const int word_size

## Friends

- bool operator!= (const subtract_with_carry_01 &__lhs, const subtract_with_carry_01 &__rhs)
- template<typename _RealType1, int __w1, int __s1, int __r1, typename _CharT, typename _Traits> std::basic_ostream< _CharT,
  _Traits > & operator<< (std::basic_ostream< _CharT, _Traits > &__os, const subtract_with_carry_01< _RealType1, __w1, __s1, __r1 > &__x)
- bool operator== (const subtract_with_carry_01 &__lhs, const subtract_with_carry_01 &__rhs)
- template<typename _RealType1, int __w1, int __s1, int __r1, typename _CharT, typename _Traits> std::basic_istream< _CharT,
  _Traits > & operator>> (std::basic_istream< _CharT, _Traits > &__is, subtract_with_carry_01< _RealType1, __w1, __s1, __r1 > &__x)

## Member Typedef Documentation

template<typename _RealType, int __w, int __s, int __r>

typedef _RealType std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::result_type

The type of the generated random value.

Definition at line 847 of file random.

## Constructor & Destructor Documentation

template<typename _RealType, int __w, int __s, int __r>

std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::subtract_with_carry_01 | ( |  | ) | `[inline]`

Constructs a default-initialized % subtract_with_carry_01 random number generator.

Definition at line 858 of file random.

template<typename _RealType, int __w, int __s, int __r>

std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::subtract_with_carry_01 | ( | unsigned long | __value | ) | `[inline, explicit]`

Constructs an explicitly seeded % subtract_with_carry_01 random number generator.

Definition at line 869 of file random.

template<typename _RealType, int __w, int __s, int __r>
template<class _Gen>

std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::subtract_with_carry_01 | ( | _Gen & | __g | ) | `[inline]`

Constructs a % subtract_with_carry_01 random number generator engine seeded from the generator function `__g`.

Parameters:

  | __g | The seed generator function.

Definition at line 882 of file random.

## Member Function Documentation

template<typename _RealType, int __w, int __s, int __r>

result_type std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::max | ( |  | ) | const`[inline]`

Gets the maximum value of the range of random floats returned by this generator.

Definition at line 916 of file random.

template<typename _RealType, int __w, int __s, int __r>

result_type std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::min | ( |  | ) | const`[inline]`

Gets the minimum value of the range of random floats returned by this generator.

Definition at line 908 of file random.

template<typename _RealType, int __w, int __s, int __r>

subtract_with_carry_01< _RealType, __w, __s, __r >::result_type std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::operator() | ( |  | ) |

Gets the next random number in the sequence.

Definition at line 494 of file random.tcc.

References std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::short_lag.

template<typename _RealType, int __w, int __s, int __r>
template<class _Gen>

void std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::seed | ( | _Gen & | __g | ) | `[inline]`

Seeds the initial state of the % subtract_with_carry_01 random number generator.

Definition at line 900 of file random.

template<typename _RealType, int __w, int __s, int __r>

void std::tr1::subtract_with_carry_01< _RealType, __w, __s, __r >::seed | ( | unsigned long | __value = `19780503` | ) |

Seeds the initial state of the random number generator.

Definition at line 453 of file random.tcc.

## Friends And Related Function Documentation

template<typename _RealType, int __w, int __s, int __r>

bool operator!= | ( | const subtract_with_carry_01< _RealType, __w, __s, __r > & | __lhs,
|  | const subtract_with_carry_01< _RealType, __w, __s, __r > & | __rhs |
| ) |  |  | `[friend]`

Compares two % subtract_with_carry_01 random number generator objects of the same type for inequality.

Parameters:

  | __lhs | A % subtract_with_carry_01 random number generator object.
  | __rhs | Another % subtract_with_carry_01 random number generator object.

Returns:
  true if the two objects are not equal, false otherwise.

Definition at line 960 of file random.

template<typename _RealType, int __w, int __s, int __r>
template<typename _RealType1, int __w1, int __s1, int __r1, typename _CharT, typename _Traits>

std::basic_ostream<_CharT, _Traits>& operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const subtract_with_carry_01< _RealType1, __w1, __s1, __r1 > & | __x |
| ) |  |  | `[friend]`

Inserts the current state of a % subtract_with_carry_01 random number generator engine `__x` into the output stream `__os`.

Parameters:

  | __os | An output stream.
  | __x | A % subtract_with_carry_01 random number generator engine.

Returns:
  The output stream with the state of `__x` inserted or in an error state.

template<typename _RealType, int __w, int __s, int __r>

bool operator== | ( | const subtract_with_carry_01< _RealType, __w, __s, __r > & | __lhs,
|  | const subtract_with_carry_01< _RealType, __w, __s, __r > & | __rhs |
| ) |  |  | `[friend]`

Compares two % subtract_with_carry_01 random number generator objects of the same type for equality.

Parameters:

  | __lhs | A % subtract_with_carry_01 random number generator object.
  | __rhs | Another % subtract_with_carry_01 random number generator object.

Returns:
  true if the two objects are equal, false otherwise.

Definition at line 937 of file random.

template<typename _RealType, int __w, int __s, int __r>
template<typename _RealType1, int __w1, int __s1, int __r1, typename _CharT, typename _Traits>

std::basic_istream<_CharT, _Traits>& operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | subtract_with_carry_01< _RealType1, __w1, __s1, __r1 > & | __x |
| ) |  |  | `[friend]`

Extracts the current state of a % subtract_with_carry_01 random number generator engine `__x` from the input stream `__is`.

Parameters:

  | __is | An input stream.
  | __x | A % subtract_with_carry_01 random number generator engine.

Returns:
  The input stream with the state of `__x` extracted or in an error state.

The documentation for this class was generated from the following files:

- random
- random.tcc